import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkInvoice, ThinkInvoiceParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkInvoice(params: ThinkInvoiceParam) {
  const res = await request.get<ApiResult<PageResult<ThinkInvoice>>>(
    THINK_API_URL + '/think/think-invoice/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkInvoice(params?: ThinkInvoiceParam) {
  const res = await request.get<ApiResult<ThinkInvoice[]>>(
    THINK_API_URL + '/think/think-invoice',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkInvoice(data: ThinkInvoice) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkInvoice(data: ThinkInvoice) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkInvoice(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkInvoice(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkInvoice(id: number) {
  const res = await request.get<ApiResult<ThinkInvoice>>(
    THINK_API_URL + '/think/think-invoice/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 开具发票
 */
export async function doInvoice(data: ThinkInvoice) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice/doInvoice',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据orderNo查询发票
 */
export async function showInvoice(id: number) {
  const res = await request.get<ApiResult<ThinkInvoice>>(
    THINK_API_URL + '/think/think-invoice/showInvoice/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
